package android.tcc;

import java.util.HashMap;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.nostra13.universalimageloader.core.ImageLoader;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.tcc.constants.ApplicationConstants;
import android.tcc.issues.Issue;
import android.tcc.json.ParseException;
import android.util.Base64;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.Gallery.LayoutParams;

public class IssueActivity extends Activity {
	
	int issueId;
	Bitmap ownerAvatar = null;
	Issue issue = new Issue();
    HashMap<String, Object> issueMap;
    final Handler mHandler = new Handler();	

    
    final Runnable requestSuccesful = new Runnable() {
        public void run() {
            requestSuccesful();
        }
    };

    final Runnable requestFailed = new Runnable() {
        public void run() {
        	requestFailed();
        }
    };    	
	
	public void onCreate(Bundle savedInstanceState){
		
        super.onCreate(savedInstanceState);
        setContentView(R.layout.issue);
		
        Bundle extras = getIntent().getExtras();
        if(extras != null) {
        	issueId = extras.getInt("selectedIssueId");
        }
        
        new Thread(){
        	public void run() {
				SharedPreferences preferences = getSharedPreferences("Ouvidusp", Context.MODE_PRIVATE);        		
        		try {
        			issueMap = issue.requestIssue("auth_token", preferences.getString("auth_token", ""), issueId);
        			mHandler.post(requestSuccesful);
				} catch (ParseException e) {
					// TODO Auto-generated catch block
					mHandler.post(requestFailed);
					e.printStackTrace();
				}
        	}
        }.start();
        
	}
	
	protected void requestFailed() {
		
	}
		
	private void requestSuccesful() {
		int i = 0;
		byte[] avatar = null;
		Bitmap decodedByte = null;
		ImageView myImageView = null;
		Button reportIssue = null;
		Button submitComment = null;
		TextView name = null;		
		TextView text = null;
		EditText myComment = null;
		TextView commentNameAndComment = null;
		JSONArray commentsArray = null;
		JSONArray picturesArray = null;
		JSONObject comment = null;
		JSONObject picture = null;
		ImageView commentsProfilePic = null;
		TableRow myCommentRow = null;
		TableRow commentRow = null;
		TableRow picturesRow = null;
		ImageButton pictureImageButton = null;
		ImageLoader imageLoader = ImageLoader.getInstance();
		
        TableLayout addresTable = (TableLayout) findViewById(R.id.AttributesTableLayout);
        TableLayout issueMainTableLayout = (TableLayout) findViewById(R.id.IssueTableLayout);
        
		text = (TextView) findViewById(R.id.IssueTitle);
		if(issueMap.get("title") != null)									
			text.setText((String) issueMap.get("title"));
		
        text = (TextView) findViewById(R.id.AddressLabel);
        text.setVisibility(View.VISIBLE);
		text = (TextView) findViewById(R.id.Address);
		if(issueMap.get("address") != null)							
			text.setText((String) issueMap.get("address"));
		
        text = (TextView) findViewById(R.id.DescriptionLabel);
        text.setVisibility(View.VISIBLE);						
		text = (TextView) findViewById(R.id.Description);
		if(issueMap.get("description") != null)
			text.setText((String) issueMap.get("description"));		
		
		text = (TextView) findViewById(R.id.PicturesLabel);
		text.setVisibility(View.VISIBLE);
		
        text = (TextView) findViewById(R.id.CommentsLabel);
        text.setVisibility(View.VISIBLE);
        
        
        picturesArray = (JSONArray) issueMap.get("pictures");
        picturesRow = (TableRow) findViewById(R.id.PicturesRow);
        for(i = 0; i < picturesArray.length(); i++){
        	try {
				picture = picturesArray.getJSONObject(i);
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
        	
        	pictureImageButton = new ImageButton(this);
        	pictureImageButton.setLayoutParams(new TableRow.LayoutParams(100, 100));
        	
			try {
				imageLoader.displayImage(ApplicationConstants.SERVER_URL + ((String) picture.get("image_string")), pictureImageButton);
				/*avatar = Base64.decode(((String) picture.get("image_string")).getBytes(), Base64.DEFAULT);*/
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			/*decodedByte = BitmapFactory.decodeByteArray(avatar, 0, avatar.length);
        	pictureImageButton.setImageBitmap(decodedByte);*/
        	try {
				pictureImageButton.setTag((String) picture.get("mobile_image_string"));
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();	
			}
        	pictureImageButton.setOnClickListener(new View.OnClickListener() {
				
				@Override
				public void onClick(View view) {
	                Intent myIntent = new Intent(view.getContext(), GaleryActivity.class);
	                myIntent.putExtra("picture", (String) view.getTag());
	                startActivityForResult(myIntent, 0);	                
				}
			});
        	picturesRow.addView(pictureImageButton);
        }
		
        commentsArray = (JSONArray) issueMap.get("comments");
        for(i = 0; i < commentsArray.length(); i++){
        	try {
				comment = commentsArray.getJSONObject(i);
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			commentRow = new TableRow(this);
			
			commentRow.setLayoutParams(new TableRow.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
			if(i%2 == 0){
				commentRow.setBackgroundColor(Color.LTGRAY);
			}
        	commentsProfilePic = new ImageView(this);
        	commentsProfilePic.setLayoutParams(new TableRow.LayoutParams(50, 50));
			commentNameAndComment = new TextView(this);
			commentNameAndComment.setTextColor(Color.BLACK);

			commentNameAndComment.setLayoutParams(new TableRow.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT, 1f));
			commentNameAndComment.setSingleLine(false);
			try {
				/*avatar = Base64.decode(((String) comment.get("owner_avatar")).getBytes(), Base64.DEFAULT);*/
				imageLoader.displayImage(ApplicationConstants.SERVER_URL + ((String) comment.get("owner_avatar")), commentsProfilePic);
				commentNameAndComment.setText(((String) comment.get("user_name")) + " disse: \n" + ((String) comment.get("comment")));
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			/*decodedByte = BitmapFactory.decodeByteArray(avatar, 0, avatar.length);
			commentsProfilePic.setImageBitmap(decodedByte);*/
			commentRow.addView(commentsProfilePic);
			commentRow.addView(commentNameAndComment);
			addresTable.addView(commentRow);
        }
        
        
        SharedPreferences preferences = getSharedPreferences("Ouvidusp", MODE_PRIVATE);
    	
		name = (TextView) findViewById(R.id.UserName);
		name.setText(preferences.getString("name", ""));
		
		/*avatar = Base64.decode(preferences.getString("encoded_avatar", "").getBytes(), Base64.DEFAULT);
		decodedByte = BitmapFactory.decodeByteArray(avatar, 0, avatar.length);*/
		
	    myImageView = (ImageView) findViewById(R.id.ProfilePicture);
	    /*myImageView.setImageBitmap(decodedByte);*/
		imageLoader.displayImage(ApplicationConstants.SERVER_URL + preferences.getString("encoded_avatar", ""), myImageView);	    
	    reportIssue = (Button) findViewById(R.id.ReportIssueButton);
	    reportIssue.setVisibility(View.VISIBLE);
	    myImageView = new ImageView(this);
	    myImageView.setLayoutParams(new TableRow.LayoutParams(50, 50));
	    myImageView.setImageBitmap(decodedByte);
	    myComment = new EditText(this);
	    myComment.setLayoutParams(new TableRow.LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT));
	    myComment.setTextColor(Color.BLACK);
	    myComment.setHint("Comente aqui");
	    myComment.setTextSize(12);
	    myCommentRow = new TableRow(this);
	    myCommentRow.setLayoutParams(new TableRow.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
	    myCommentRow.addView(myImageView);
	    myCommentRow.addView(myComment);
	    addresTable.addView(myCommentRow);
	    
	    
	    submitComment = new Button(this);
	    submitComment.setLayoutParams(new TableRow.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
	    submitComment.setText(R.string.submit_comment);
	    submitComment.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				
			}
		});
	    
	    issueMainTableLayout.addView(submitComment);
		
	}
	
}
