package android.tcc;

import com.nostra13.universalimageloader.core.ImageLoader;
import com.nostra13.universalimageloader.core.ImageLoaderConfiguration;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Handler;
import android.tcc.auth.Authorization;
import android.tcc.json.ParseException;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.TextView;

public class LoginActivity extends Activity {
    Button loginButton;
    EditText login;
    EditText password;
    EditText latitude;
    EditText longitude;
    TextView errorMessage;
    ProgressBar progressBar;
	protected String loginString = null;
	protected String passwordString = null;
	protected boolean loginResult = false;
	String connectionError = null;
    final Handler mHandler = new Handler();
    
    final Runnable loginSuccesful = new Runnable() {
        public void run() {
            loginSuccesful();
        }
    };

    final Runnable loginFailed = new Runnable() {
        public void run() {
            loginFailed();
        }
    };
    
    
    public void onCreate(Bundle savedInstanceState) {     
    	super.onCreate(savedInstanceState);
    	
    	ImageLoaderConfiguration config = new ImageLoaderConfiguration.Builder(getApplicationContext()).build();

    	ImageLoader.getInstance().init(config);
    	
    	setContentView(R.layout.login);
    	final Authorization auth = new Authorization(this.getApplicationContext());	
    	loginButton = (Button) findViewById(R.id.LoginButton);
    	loginButton.setOnClickListener(new View.OnClickListener() {
            
			public void onClick(View v) {
				progressBar = (ProgressBar) findViewById(R.id.LoginProgressBar);
				progressBar.setVisibility(View.VISIBLE);
				login = (EditText) findViewById(R.id.Login);
				loginString = login.getText().toString();
				login.setVisibility(View.INVISIBLE);
				password = (EditText) findViewById(R.id.PassWord);
				passwordString = password.getText().toString();
				password.setVisibility(View.INVISIBLE);
				loginButton = (Button) findViewById(R.id.LoginButton);
				loginButton.setVisibility(View.INVISIBLE);
				errorMessage = (TextView) findViewById(R.id.ErrorMessage);
				errorMessage.setVisibility(View.INVISIBLE);
				new Thread(){
					 public void run() {
							try {
								auth.requestLogin(loginString, passwordString);
							} catch (ParseException e) {
								connectionError = e.getMessage();
								mHandler.post(loginFailed);
								return;
							}
							mHandler.post(loginSuccesful);
			         }
				}.start();
			}
		});
    }
    
    protected void loginSuccesful(){
            Intent myIntent = new Intent(findViewById(R.id.MainLayout).getContext(), MainActivity.class);
            SharedPreferences preferences = getSharedPreferences("Ouvidusp", MODE_PRIVATE);
            myIntent.putExtra("Nome", preferences.getString("name", ""));
            startActivityForResult(myIntent, 0);
    }
    
    protected void loginFailed(){
		progressBar.setVisibility(View.INVISIBLE);
		login.setVisibility(View.VISIBLE);
		password.setVisibility(View.VISIBLE);		
		loginButton.setVisibility(View.VISIBLE);
		errorMessage.setText(connectionError);
		errorMessage.setVisibility(View.VISIBLE);
    }
	
}