package android.tcc;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import org.json.JSONException;
import org.json.JSONObject;

import com.nostra13.universalimageloader.core.ImageLoader;

import android.app.Activity;
import android.app.Application;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.tcc.constants.ApplicationConstants;
import android.tcc.issues.IssuesList;
import android.tcc.json.ParseException;
import android.util.Base64;
import android.view.View;
import android.widget.Button;
import android.widget.Gallery.LayoutParams;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

public class MainActivity extends Activity {
	TextView name;
	Button reportIssue;
	IssuesList issue = new IssuesList();
	String connectionError = null;
    final Handler mHandler = new Handler();
    HashMap<String, Object> issuesMap;
    
    
    final Runnable requestSuccesful = new Runnable() {
        public void run() {
            requestSuccesful();
        }
    };

    final Runnable requestFailed = new Runnable() {
        public void run() {
        	requestFailed();
        }
    };    
	
	public void onCreate(Bundle savedInstanceState){
    	super.onCreate(savedInstanceState);
    	    	
    	setContentView(R.layout.main);    	
		new Thread(){
			 public void run() {
					try {
						SharedPreferences preferences = getSharedPreferences("Ouvidusp", Context.MODE_PRIVATE);
						issuesMap = issue.requestIssues("auth_token", preferences.getString("auth_token", ""));
						mHandler.post(requestSuccesful);
					} catch (ParseException e) {
						connectionError = e.getMessage();
						mHandler.post(requestFailed);
						return;
					}
	         }
		}.start();
	}
	
	
	protected void requestFailed() {
			
	}
		
	private void requestSuccesful() {
		String key = null;
		JSONObject issue = null;
		byte[] avatar = null;
		Bitmap decodedByte = null;
		ImageView myImageView = null;
		TextView issueView = null;
		Button reportIssue = null;
		TableRow row = null;
		ImageButton imageIssueButton = null;		
		Set<String> keys = issuesMap.keySet();
		Iterator<String> it = keys.iterator();

		
		TableLayout mainContentLayout = (TableLayout) findViewById(R.id.MainTableLayout);
		ImageLoader imageLoader = ImageLoader.getInstance();
		while(it.hasNext()){
			key = it.next();
			issue = (JSONObject) issuesMap.get(key);
			
			issueView = new TextView(this);
			myImageView = new ImageView(this);
			imageIssueButton = new ImageButton(this);
			try {
				issueView.setTextColor(Color.BLACK);
				issueView.setText(((String) issue.get("user_name")) + " reportou sobre \n" + ((String) issue.get("title")));
				issueView.setVisibility(View.VISIBLE);
				
				//avatar = Base64.decode(((String) issue.get("owner_avatar")).getBytes(), Base64.DEFAULT);
				//decodedByte = BitmapFactory.decodeByteArray(avatar, 0, avatar.length);
				imageIssueButton.setLayoutParams(new TableRow.LayoutParams(100, 100));
				imageLoader.displayImage(ApplicationConstants.SERVER_URL + ((String) issue.get("owner_avatar")), imageIssueButton);
				//imageIssueButton.setImageBitmap(Bitmap.createScaledBitmap(decodedByte, 100, 100, true));
				imageIssueButton.setTag(issue.getInt("id"));
				imageIssueButton.setOnClickListener(new View.OnClickListener() {
					
					@Override
					public void onClick(View view) {
		                Intent myIntent = new Intent(view.getContext(), IssueActivity.class);
		                Bundle bundle = new Bundle();
		                bundle.putInt("selectedIssueId", (Integer) view.getTag());
		                myIntent.putExtras(bundle);
		                startActivityForResult(myIntent, 0);						
					}
				});
				
				row = new TableRow(this);
				row.setLayoutParams(new TableRow.LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT));
				row.addView(imageIssueButton);								
				row.addView(issueView);				
				mainContentLayout.addView(row, new TableLayout.LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT));
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
        SharedPreferences preferences = getSharedPreferences("Ouvidusp", MODE_PRIVATE);
    	
		name = (TextView) findViewById(R.id.UserName);
		name.setText(preferences.getString("name", ""));
		
		//avatar = Base64.decode(preferences.getString("encoded_avatar", "").getBytes(), Base64.DEFAULT);
		//decodedByte = BitmapFactory.decodeByteArray(avatar, 0, avatar.length);
		
	    myImageView = (ImageView) findViewById(R.id.ProfilePicture);
	    //myImageView.setImageBitmap(decodedByte);
	    imageLoader.displayImage(ApplicationConstants.SERVER_URL + preferences.getString("encoded_avatar", ""), myImageView);
	    reportIssue = (Button) findViewById(R.id.ReportIssueButton);
	    reportIssue.setVisibility(View.VISIBLE);
	    ProgressBar progressBar = (ProgressBar) findViewById(R.id.IssueListProgressBar);
	    mainContentLayout.removeView(progressBar);
	    
	}
	
	
}
