package android.tcc.auth;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import org.json.JSONObject;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.tcc.constants.ApplicationConstants;
import android.tcc.json.AuthJSONParser;
import android.tcc.json.JSONParser;
import android.tcc.json.JsonDataExchange;
import android.tcc.json.ParseException;

public class Authorization {
	private Context context;

	public Authorization(Context context){
		this.context = context;
	}
	
	public boolean requestLogin(String email, String password) throws ParseException{
		String response = null;
		JSONObject jsonRequest = null;
		JSONObject jsonResponse = null;		
		AuthJSONParser authParser = new AuthJSONParser();
		JsonDataExchange jsonDE = new JsonDataExchange();
		
		HashMap<String, Object> loginInfoMap = new HashMap<String, Object>();
		loginInfoMap.put("email", email);
		loginInfoMap.put("password", password);	
		
		jsonRequest = authParser.encode(loginInfoMap);
		try{
			jsonResponse = jsonDE.sendJson(ApplicationConstants.SERVER_URL + ApplicationConstants.API_ROOT + ApplicationConstants.AUTH_API, jsonRequest);
		} catch (Exception e) {
			// TODO: handle exception
		}
		try{
			loginInfoMap = authParser.decode(jsonResponse);
		} catch (AuthException e) {
			throw e;
		}
		
		SharedPreferences preferences = context.getSharedPreferences("Ouvidusp", context.MODE_PRIVATE);
		SharedPreferences.Editor prefEditor = preferences.edit();
		
		Set<String> keySet = loginInfoMap.keySet();
		Iterator<String> it = keySet.iterator();
		
		while(it.hasNext()){
			response = (String) it.next();
			if(loginInfoMap.get(response) instanceof String){
				prefEditor.putString(response, (String) loginInfoMap.get(response));
			}
			else{
				prefEditor.putInt(response, Integer.parseInt(loginInfoMap.get(response).toString()));
			}
				
		}
		
		prefEditor.apply();
		return true;
		

	}
	

}
