package android.tcc.httpconnection;

import java.io.IOException;
import java.util.ArrayList;

import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.NameValuePair;
import org.apache.http.ParseException;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.params.ConnManagerParams;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.CoreConnectionPNames;
import org.apache.http.params.CoreProtocolPNames;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.params.HttpProtocolParamBean;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.util.EntityUtils;
import org.json.JSONObject;

public class HttpClient {
	private static HttpClient client;
	
	private HttpClient(){
		
	}
	
	public static synchronized HttpClient getInstance(){
		if(client == null)
			client = new HttpClient();
		
		return client;
	}
	
	
	public synchronized String makeRequest(JSONObject json, String url) throws Exception {
		String output = null;
		HttpResponse httpResponse;
		HttpPost httpPost = new HttpPost(url);
		HttpParams params = new BasicHttpParams();
		HttpProtocolParams.setVersion(params, HttpVersion.HTTP_1_1);
		DefaultHttpClient httpClient = new DefaultHttpClient(params);
		StringEntity entity = new StringEntity(json.toString());
		HttpConnectionParams.setConnectionTimeout(params, 30000);
		httpPost.setParams(params);
		httpPost.setEntity(entity);
		httpPost.setHeader("Accept", "application/json");
		httpPost.setHeader("Content-type", "application/json");
		
		httpResponse = httpClient.execute(httpPost);
		if(httpResponse != null)
			output = EntityUtils.toString(httpResponse.getEntity());
		
		return output;
	}
	
}
