class Admin::IssueStatusesController < ApplicationController
  before_filter :authenticate_user!, :is_admin?
  
  def index
    @issue_statuses = IssueStatus.find(:all)
    @issue_status = IssueStatus.new
  end


  def create
    @issue_status = IssueStatus.new(params[:issue_status])
    respond_to do |format|
      if @issue_status.save
        format.html  { redirect_to(:action => "index") }
      	format.json  { render :json => @issue_status,
                    		:status => :created, :location => @issue_status }
      else
      	format.html  { render :action => "index" }
      	format.json  { render :json => @issue_status.errors,
                    		:status => :unprocessable_entity }
      end
    end
  end

  def update
    @issue_status = IssueStatus.new(params[:id])

    if @issue_status.update_attributes(params[:issue_status])
      flash[:notice] = "Status salvo com sucesso"
      redirect_to(:action => "index")
    else
      flash[:error] = "Ocorreu um erro ao salvar status"
      redirect_to(:action => "index")
    end

  end


  def destroy
    @issue_status = ProblemsNature.find(params[:id])

    

    @issue_status.destroy
	 
    respond_to do |format|
      format.html { redirect_to :action => "index" }
      format.json { head :no_content }
    end
  end

end
