class Api::V1::CommentsForMobileController < ApplicationController
  before_filter :authenticate_user!
  respond_to :json

  def create
    issue_id = params[:issue_id]

    if request.format != :json
      render :status => 406, :json => {:message=>"The request must be json"}
      return
    end

    if issue_id.nil?
      render :status => 400, :json => {:message=>"The request must contain the issue id."}
      return
    end

    @issue = Issue.find(issue_id)

    if @issue.nil?
      logger.info("Issue cannot be found.")
      render :status => 401, :json => {:message => "Request for non existent issue."}
      return      
    end

    @issue.owner_avatar = @issue.user.avatar.url
    @issue.user_name = @issue.user.name
 
    @issue.comments.includes(:user)
    @issue.comments.each do |comment|
      comment.owner_avatar = comment.user.avatar.url(:thumb)
      comment.user_name = comment.user.name
    end

    @issue.pictures.each do |picture|
      picture.image_string = picture.image.url(:mobile_fit)
      picture.mobile_image_string = picture.image.url(:mobile_galery)
    end

    render :status => 200, :json => {:issue => @issue.as_json(false)}

  end

end
