class Api::V1::IssuesForMobileController < ApplicationController
  before_filter :authenticate_user!
  respond_to :json

  def create
    @issues = Issue.select("id, user_id, title").includes(:user).limit(10).order("updated_at DESC")
    
    @issues.each do |issue|  
      issue.owner_avatar = issue.user.avatar.url(:mobile_fit)
      issue.user_name = issue.user.name
    end


    render :status => 200, :json => {:issues => @issues.as_json(:resume => true)}
  end

end
