class IssuesController < ApplicationController
  before_filter :authenticate_user!

  def index
    @issues = current_user.issues
    respond_to do |format|
      format.html  # index.html.erb
      format.json  { render :json => @issues }
    end
  end

  def show
    @issue = current_user.issues.find(params[:id])
    @problemsnatures = ProblemsNature.all
    @issue_status = IssueStatus.all
    @issue.comments.build
    @issue.pictures.build
  end


  def new
    @issue = Issue.new
    @problemsnatures = ProblemsNature.all
    @issue_status = IssueStatus.all
    @issue.comments.build
    @issue.pictures.build
    respond_to do |format|
      format.html  # new.html.erb
      format.json  { render :json => @issue }
    end
  end

  def create
    @issue = current_user.issues.build(params[:issue])
 
    respond_to do |format|
      if @issue.save
        format.html  { redirect_to(@issue,
                 		:notice => 'Problema was successfully created.') }
      	format.json  { render :json => @issue,
                    		:status => :created, :location => @issue }
      else
        @problemsnatures = ProblemsNature.all
        @issue_status = IssueStatus.all
        @issue.comments.build
        @issue.pictures.build
      	format.html  { render :action => "new" }
      	format.json  { render :json => @issue.errors,
                    		:status => :unprocessable_entity }
      end
    end
  end

  def update
    @issue = current_user.issues.find(params[:id])

    respond_to do |format|
      if @issue.update_attributes(params[:issue])
        format.html  { redirect_to(@issue,
		            :notice => 'Problema was successfully updated.') }
        format.json  { head :no_content }
      else
        format.html  { render :action => "edit" }
        format.json  { render :json => @issue.errors,
		            :status => :unprocessable_entity }
      end
    end
  end

  def edit
    @issue = current_user.issues.find(params[:id])
    @issue.comments.build
    @issue.pictures.build
    respond_to do |format|
      format.html  # edit.html.erb
      format.json  { render :json => @issue }
    end

  end

  def destroy
    @issue = current_user.issues.find(params[:id])
    @issue.destroy
	 
    respond_to do |format|
      format.html { redirect_to :action => "index" }
      format.json { head :no_content }
    end
  end


end
