class Picture < ActiveRecord::Base
  attr_accessible :image, :issue_id
  belongs_to :issue
  mount_uploader :image, PictureUploader

  attr_accessor :mobile_image_string
  attr_accessor :image_string

  def image=(val)
    if !val.is_a?(String) && valid?
      image_will_change!
      super
    end
  end

  def as_json(resume = false)
    {
      :issue_id => issue_id,
      :mobile_image_string => mobile_image_string,
      :image_string => image_string
    }
  end
end
