class User < ActiveRecord::Base
  mount_uploader :avatar, AvatarUploader
  # Include default devise modules. Others available are:
  # :token_authenticatable, :confirmable,
  # :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable, :token_authenticatable

  before_save :ensure_authentication_token

  has_many :issues
  has_many :followed_issues, :through => :follow_issue
  has_many :avatars

  def as_json(options={})
    {
      :name => name,
      :email => email,
      :id => id,
      :auth_token => authentication_token,
      :encoded_avatar => encoded_avatar
    }
  end

attr_accessor :encoded_avatar

  # Setup accessible (or protected) attributes for your model
 attr_accessible :name, :email, :password, :latitude, :longitude, :password_confirmation, :remember_me, :authentication_token, :avatar, :avatar_cache, :remove_avatar

accepts_nested_attributes_for :avatars, :allow_destroy => true
  # attr_accessible :title, :body
end
